' OPera code GENerator
' generates Opera keying sequence originally defined by Jose Ros EA5HVK
' emulation based on protocol description by Guido PE1NNZ
'  http://rn3aus.narod.ru/opera_protocol.pdf

' implemented by DF6NM
' v1 12-07-14
' v2a 12-07-16

' usage: opgen aa1aa >opera.txt

DEFLNG A-Z

'call$ = "AA1AA"
call$ = COMMAND$

'align callsign
call$ = UCASE$(call$)
call$ = "      " + call$ + "      "
'look for last number
n1 = 0
FOR n = 1 TO LEN(call$)
 a = ASC(MID$(call$, n, 1))
 IF a >= ASC("0") AND a <= ASC("9") THEN n1 = n
NEXT n
IF n1 < 6 OR n1 > LEN(call$) - 6 THEN PRINT "no number found in callsign": END
call$ = MID$(call$, n1 - 2, 6)
'PRINT "["; call$; "]"

'callsign into 28 bits
c1 = ASC(MID$(call$, 1, 1))
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
IF c1 >= 48 AND c1 < 58 THEN c2 = c1 - 48 + 27
c = c2
c1 = ASC(MID$(call$, 2, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 65
IF c1 >= 48 AND c1 < 58 THEN c2 = c1 - 48 + 26
c = c * 36 + c2
c1 = ASC(MID$(call$, 3, 1))
c2 = 0
IF c1 >= 48 AND c1 < 58 THEN c2 = c1 - 48
c = c * 10 + c2
c1 = ASC(MID$(call$, 4, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
c = c * 27 + c2
c1 = ASC(MID$(call$, 5, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
c = c * 27 + c2
c1 = ASC(MID$(call$, 6, 1))
c2 = 0
IF c1 > 64 AND c1 < 91 THEN c2 = c1 - 64
c = c * 27 + c2
'PRINT c

' ascii 01 sequence
c$ = RIGHT$(STRING$(7, "0") + HEX$(c), 7)
h$ = c$: GOSUB hextobin
'PRINT h$, b$
cb$ = b$

'first crc
b$ = cb$: GOSUB calccrc
h$ = crc$
'h$ = "0c1e"
GOSUB hextobin

' replace zeroes by 2b and 1b, swap bytes
IF MID$(b$, 1, 8) = "00000000" THEN MID$(b$, 1, 8) = "00101011"
IF MID$(b$, 9, 8) = "00000000" THEN MID$(b$, 9, 8) = "00011011"
b$ = MID$(b$, 9, 8) + MID$(b$, 1, 8)
cb$ = cb$ + b$
'PRINT cb$

'second crc
b$ = cb$: GOSUB calccrc: h$ = crc$
'h$ = "6cac"
GOSUB hextobin

'append 4 zero bits and 3bits from crc
b$ = MID$(b$, 6, 3)
cb$ = "0000" + cb$ + b$
'PRINT cb$, LEN(cb$)

'xor with scrambling vector
h$ = "70ABF3680C8AB"
GOSUB hextobin
prn$ = RIGHT$(b$, 51)
FOR n = 1 TO 51
 x = (ASC(MID$(prn$, n, 1)) - 48) XOR (ASC(MID$(cb$, n, 1)) - 48)
 MID$(cb$, n, 1) = CHR$(48 + x)
NEXT n
'PRINT cb$

'Welsh-Hadamard 3 to 7 bit
hd$ = ""
hd$ = hd$ + "0000000" + "1010101" + "0110011" + "1100110"
hd$ = hd$ + "0001111" + "1011010" + "0111100" + "1101001"

hd1$ = ""
FOR n = 0 TO 17 - 1
 a$ = MID$(cb$, 3 * n + 1, 3)
 a = 0
 FOR n1 = 1 TO 3
  a = a * 2 + ASC(MID$(a$, n1, 1)) - 48
 NEXT n1
 'PRINT a;
 hd1$ = hd1$ + MID$(hd$, 1 + a * 7, 7)
NEXT n
'PRINT : PRINT hd1$; LEN(hd1$)

'interleave 7x17
hd2$ = ""
FOR n = 0 TO 6
 FOR n2 = 0 TO 16
  hd2$ = hd2$ + MID$(hd1$, 1 + n2 * 7 + n, 1)
 NEXT n2
 hd2$ = hd2$ '+ " "
NEXT n
'PRINT hd2$; LEN(hd2$)

'manchester encoding, add 11, omit last bit
man$ = ""
FOR n = 1 TO 17 * 7
 IF MID$(hd2$, n, 1) = "1" THEN m1$ = "01" ELSE m1$ = "10"
 man$ = man$ + m1$
NEXT n
man$ = LEFT$("11" + man$, 239)
'PRINT
PRINT man$

'output to _callsign.txt
'OPEN "_" + call$ + ".txt" FOR OUTPUT AS 1
' PRINT #1, man$;
'CLOSE 1

END


hextobin:
 b$ = ""
 FOR n = 1 TO LEN(h$)
  h1 = VAL("&h" + MID$(h$, n, 1))
  FOR n2 = 1 TO 4
   b1$ = CHR$(48 + (h1 \ 8))
   b$ = b$ + b1$
   h1 = (2 * h1) AND 15
  NEXT n2
 NEXT n
RETURN

calccrc:
 'ascii 0 and 1 bytes, lsb first
 poly& = &H8005&:
 crc& = 0
 FOR nbyte = 1 TO LEN(b$)
  bb = ASC(MID$(b$, nbyte, 1))
  FOR nbit = 0 TO 7
   IF (bb AND 1) <> (crc& \ &H8000&) THEN
    crc& = (crc& + crc&) AND &HFFFF&  'shiftl
    crc& = crc& XOR poly&
   ELSE
    crc& = (crc& + crc&) AND &HFFFF&  'shiftl
   END IF
   bb = bb \ 2
  NEXT nbit
 NEXT nbyte
 'reverse CRC result
 crc1& = 0
 FOR nbit = 0 TO 15
  crc1& = 2 * crc1& + (crc& AND 1&)
  crc& = crc& \ 2
 NEXT nbit
 crc& = crc1&
 crc$ = RIGHT$("0000" + HEX$(crc&), 4)
 'PRINT "crc="; crc$
RETURN

